/* Mandatory boundary constants */
#define MaxInstances 100
#define MaxLinks 10000 //always MaxInstances^2
#define MaxObjectInstances 100
#define MaxGuardComposition 100
#define MaxSteps 50

/* Other model specific constants if required */

/* constants denoting the execution state of a p system - use the step_complete in verification formulae */
mtype = {running, step_complete}
mtype state = running;

/* The alphabet */
//mapping of symbols to integers so we can use arrays as maps with these as keys instead
#define @A_1_1 0
#define @A_1_2 1
#define @A_1_3 2
#define @A_1_4 3
#define @A_1 4
#define @A_2_1 5
#define @A_2_2 6
#define @A_2_3 7
#define @A_2_4 8
#define @A_2 9
#define @A_3_1 10
#define @A_3_2 11
#define @A_3_3 12
#define @A_3_4 13
#define @A_3 14
#define @A_4 15
#define @B_1 16
#define @B_2 17
#define @B_3 18
#define @B_4 19
#define @G_1 20
#define @G_2 21
#define @G_3 22
#define @G_4 23
#define @R_1 24
#define @R_2 25
#define @R_3 26
#define @R_4 27
#define @T 28
#define @T_1 29
#define @T_2 30
#define @T_3 31
#define @T_4 32
#define @X 33
#define @X_10 34
#define @X_11 35
#define @X_1 36
#define @X_2 37
#define @X_3 38
#define @X_4 39
#define @X_5 40
#define @X_6 41
#define @X_7 42
#define @X_8 43
#define @X_9 44
#define @Y 45
#define @a 46
#define @no 47
#define @s 48
#define @yes 49
#define A_LENGTH 50

int step = 0;
int instanceCount = 0;
int linksCount = 0;

typedef MInstance {
	byte type;
	int x[A_LENGTH] = 0;
	int x_temp[A_LENGTH] = 0;
	byte isComputing = false;
	byte isDissolved = false;
}

/* A link between the indices corresponding to the membrane instances in the membrane instance array */
typedef MLink {
	int m1Index;
	int m2Index;
}

/* Membrane instances */
MInstance ms[MaxInstances];
/* Membrane links */
MLink ml[MaxLinks];

/* For each instance we have:
	- x, the vector of symbols from the alphabet
	- n is the value (multiplicity) associated with each object
*/

inline printInstanceData(instanceIndex) {
	d_step {
		printf("\n%d %d %d ", step, ms[instanceIndex].type, instanceIndex);
					if 
					::	ms[instanceIndex].x[@A_1_1] >= 1 -> printf("A_1_1:%d,", ms[instanceIndex].x[@A_1_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_1_2] >= 1 -> printf("A_1_2:%d,", ms[instanceIndex].x[@A_1_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_1_3] >= 1 -> printf("A_1_3:%d,", ms[instanceIndex].x[@A_1_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_1_4] >= 1 -> printf("A_1_4:%d,", ms[instanceIndex].x[@A_1_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_1] >= 1 -> printf("A_1:%d,", ms[instanceIndex].x[@A_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_2_1] >= 1 -> printf("A_2_1:%d,", ms[instanceIndex].x[@A_2_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_2_2] >= 1 -> printf("A_2_2:%d,", ms[instanceIndex].x[@A_2_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_2_3] >= 1 -> printf("A_2_3:%d,", ms[instanceIndex].x[@A_2_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_2_4] >= 1 -> printf("A_2_4:%d,", ms[instanceIndex].x[@A_2_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_2] >= 1 -> printf("A_2:%d,", ms[instanceIndex].x[@A_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_3_1] >= 1 -> printf("A_3_1:%d,", ms[instanceIndex].x[@A_3_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_3_2] >= 1 -> printf("A_3_2:%d,", ms[instanceIndex].x[@A_3_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_3_3] >= 1 -> printf("A_3_3:%d,", ms[instanceIndex].x[@A_3_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_3_4] >= 1 -> printf("A_3_4:%d,", ms[instanceIndex].x[@A_3_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_3] >= 1 -> printf("A_3:%d,", ms[instanceIndex].x[@A_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@A_4] >= 1 -> printf("A_4:%d,", ms[instanceIndex].x[@A_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@B_1] >= 1 -> printf("B_1:%d,", ms[instanceIndex].x[@B_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@B_2] >= 1 -> printf("B_2:%d,", ms[instanceIndex].x[@B_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@B_3] >= 1 -> printf("B_3:%d,", ms[instanceIndex].x[@B_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@B_4] >= 1 -> printf("B_4:%d,", ms[instanceIndex].x[@B_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@G_1] >= 1 -> printf("G_1:%d,", ms[instanceIndex].x[@G_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@G_2] >= 1 -> printf("G_2:%d,", ms[instanceIndex].x[@G_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@G_3] >= 1 -> printf("G_3:%d,", ms[instanceIndex].x[@G_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@G_4] >= 1 -> printf("G_4:%d,", ms[instanceIndex].x[@G_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@R_1] >= 1 -> printf("R_1:%d,", ms[instanceIndex].x[@R_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@R_2] >= 1 -> printf("R_2:%d,", ms[instanceIndex].x[@R_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@R_3] >= 1 -> printf("R_3:%d,", ms[instanceIndex].x[@R_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@R_4] >= 1 -> printf("R_4:%d,", ms[instanceIndex].x[@R_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@T] >= 1 -> printf("T:%d,", ms[instanceIndex].x[@T]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@T_1] >= 1 -> printf("T_1:%d,", ms[instanceIndex].x[@T_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@T_2] >= 1 -> printf("T_2:%d,", ms[instanceIndex].x[@T_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@T_3] >= 1 -> printf("T_3:%d,", ms[instanceIndex].x[@T_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@T_4] >= 1 -> printf("T_4:%d,", ms[instanceIndex].x[@T_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X] >= 1 -> printf("X:%d,", ms[instanceIndex].x[@X]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_10] >= 1 -> printf("X_10:%d,", ms[instanceIndex].x[@X_10]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_11] >= 1 -> printf("X_11:%d,", ms[instanceIndex].x[@X_11]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_1] >= 1 -> printf("X_1:%d,", ms[instanceIndex].x[@X_1]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_2] >= 1 -> printf("X_2:%d,", ms[instanceIndex].x[@X_2]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_3] >= 1 -> printf("X_3:%d,", ms[instanceIndex].x[@X_3]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_4] >= 1 -> printf("X_4:%d,", ms[instanceIndex].x[@X_4]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_5] >= 1 -> printf("X_5:%d,", ms[instanceIndex].x[@X_5]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_6] >= 1 -> printf("X_6:%d,", ms[instanceIndex].x[@X_6]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_7] >= 1 -> printf("X_7:%d,", ms[instanceIndex].x[@X_7]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_8] >= 1 -> printf("X_8:%d,", ms[instanceIndex].x[@X_8]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@X_9] >= 1 -> printf("X_9:%d,", ms[instanceIndex].x[@X_9]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@Y] >= 1 -> printf("Y:%d,", ms[instanceIndex].x[@Y]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@a] >= 1 -> printf("a:%d,", ms[instanceIndex].x[@a]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@no] >= 1 -> printf("no:%d,", ms[instanceIndex].x[@no]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@s] >= 1 -> printf("s:%d,", ms[instanceIndex].x[@s]);
					::	else -> skip;
					fi;
					if 
					::	ms[instanceIndex].x[@yes] >= 1 -> printf("yes:%d,", ms[instanceIndex].x[@yes]);
					::	else -> skip;
					fi;

	}
}

proctype Log(int instanceIndex) {
	d_step {
		/*printf("--------- configuration #%d ----------\n\n", step);*/
		int i;
		if
			:: instanceIndex >= 0 && instanceIndex < instanceCount -> printInstanceData(instanceIndex);
			:: instanceIndex == -1 ->
				for(i: 0 .. instanceCount - 1) {
					if
					::	ms[i].isDissolved == false ->
						printInstanceData(i);
					::	else -> skip;
					fi;	
				}
			:: else -> skip;
		fi;
		/*printf("\n------------------------------------\n\n");*/
	}
}

/* Executes a rewrite operation for instance denoted by index "instanceIndex" 
 * Object communication is considered as a rewrite operation across compartments
 * OBSOLETE!!!
 */
inline doRewrite(src_instanceIndex, tar_instanceIndex, symbol1, n1, symbol2, n2) {
	d_step {
		ms[src_instanceIndex].x[symbol1] = ms[src_instanceIndex].x[symbol1] - n1;
		ms[tar_instanceIndex].x_temp[symbol2] = ms[tar_instanceIndex].x_temp[symbol2] + n2;
	}
}

inline doLhs(instanceIndex, symbol, n) {
	ms[instanceIndex].x[symbol] = ms[instanceIndex].x[symbol] - n;
}

inline doRhs(instanceIndex, symbol, n) {
	ms[instanceIndex].x_temp[symbol] = ms[instanceIndex].x_temp[symbol] + n;
}

inline doReplicate(tar_type, symbol, n) {
	d_step {
		int i;
		for(i: 0 .. instanceCount - 1) {
			if
				:: ms[i].type == tar_type -> doRhs(i, symbol, n);
				:: else -> skip;
			fi;

		}
	}
}

inline create(instanceIndex, tar_type, childCount) {
	int i, j, k;
	for(i: 0 .. childCount - 1) {
		ms[instanceCount].type = tar_type;
		for(j: 0 .. A_LENGTH - 1) {
			ms[instanceCount].x[j] = ms[instanceIndex].x[j];
		}
		//all the links subject to the parent membrane are now inherited by the created membranes
		for(k: 0 .. linksCount - 1) {
			if
				:: ml[k].m1Index == instanceIndex || ml[k].m2Index == instanceIndex -> 
					ml[linksCount].m1Index = instanceCount; ml[linksCount].m2Index = k; linksCount++; 
				:: else -> skip;
			fi;
		}
		instanceCount++;
	}
}

inline divide(instanceIndex, childCount) {
	//the first membrane remains unchanged in the division process
	//additional rewriting should be done using the rewrite procedure after the division
	//for rules which do division and rewriting in one step
	int i, j, k;
	for(i: 1 .. childCount - 1) {
		ms[instanceCount].type = ms[instanceIndex].type;
		for(j: 0 .. A_LENGTH - 1) {
			ms[instanceCount].x[j] = ms[instanceIndex].x[j];
		}
		//all the links subject to the parent membrane are now inherited by the created membranes
		for(k: 0 .. linksCount - 1) {
			if
				:: ml[k].m1Index == instanceIndex || ml[k].m2Index == instanceIndex -> 
					ml[linksCount].m1Index = instanceCount; ml[linksCount].m2Index = k; linksCount++; 
				:: else -> skip;
			fi;
		}
		instanceCount++;
	}
}

inline doDissolve(instanceIndex) {
	//mark the membrane instance located at instanceIndex as dissolved
	ms[instanceIndex].isDissolved = true;
}

inline rulesApplied() {
	for(i: 0 .. instanceCount - 1) {
		ms[i].isComputing == false;
	}
}

inline completeStep() {
	for(i: 0 .. instanceCount - 1) {
		for(j: 0 .. A_LENGTH - 1) {
			ms[i].x[j] = ms[i].x[j] + ms[i].x_temp[j];
			ms[i].x_temp[j] = 0;
		}
	}
}

proctype Scheduler() {
	int i, j = 0;
	int instanceCountAux;
	do
	:: (step < MaxSteps) ->
		state = running;
		instanceCountAux = instanceCount - 1;
		for(i : 0 .. instanceCountAux) {
			if
			:: (ms[i].isDissolved == false && ms[i].type == 1) -> run M2(i);
			:: (ms[i].isDissolved == false && ms[i].type == 2) -> run M1(i);
			:: else -> skip;
			fi;
		}
		rulesApplied();
		completeStep();
		/*printf("--------- Step %d complete! ----------\n\n", step);*/
		state = step_complete;
		step++;
		run Log(-1);
	:: else -> break;
	od;

	//run Log(-1);
}

proctype M2(int instanceIndex) {

	ms[instanceIndex].isComputing = true;

	/* Guard Evaluations */
	byte r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11;
	r1 = false; r2 = false; r3 = false; r4 = true; r5 = true; r6 = true; r7 = false; r8 = true; r9 = false; r10 = true; r11 = true;
	if
	::	(ms[instanceIndex].x[@s] == 1) -> r1 = true;
	::	else -> skip;
	fi;
	if
	::	(ms[instanceIndex].x[@s] == 1) -> r2 = true;
	::	else -> skip;
	fi;
	if
	::	(ms[instanceIndex].x[@s] == 1) -> r3 = true;
	::	else -> skip;
	fi;
	if
	::	(ms[instanceIndex].x[@s] == 1) -> r7 = true;
	::	else -> skip;
	fi;
	if
	::	(ms[instanceIndex].x[@A_1_1] == 1 && ms[instanceIndex].x[@B_1] == 1 && ms[instanceIndex].x[@B_1] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_2] == 1 && ms[instanceIndex].x[@B_1] == 1 && ms[instanceIndex].x[@B_2] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_3] == 1 && ms[instanceIndex].x[@B_1] == 1 && ms[instanceIndex].x[@B_3] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_4] == 1 && ms[instanceIndex].x[@B_1] == 1 && ms[instanceIndex].x[@B_4] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_2_1] == 1 && ms[instanceIndex].x[@B_2] == 1 && ms[instanceIndex].x[@B_1] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_2] == 1 && ms[instanceIndex].x[@B_2] == 1 && ms[instanceIndex].x[@B_2] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_3] == 1 && ms[instanceIndex].x[@B_2] == 1 && ms[instanceIndex].x[@B_3] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_4] == 1 && ms[instanceIndex].x[@B_2] == 1 && ms[instanceIndex].x[@B_4] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_3_1] == 1 && ms[instanceIndex].x[@B_3] == 1 && ms[instanceIndex].x[@B_1] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_2] == 1 && ms[instanceIndex].x[@B_3] == 1 && ms[instanceIndex].x[@B_2] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_3] == 1 && ms[instanceIndex].x[@B_3] == 1 && ms[instanceIndex].x[@B_3] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_4] == 1 && ms[instanceIndex].x[@B_3] == 1 && ms[instanceIndex].x[@B_4] == 1 && ms[instanceIndex].x[@A_3_3] != 1 || ms[instanceIndex].x[@A_1_1] == 1 && ms[instanceIndex].x[@G_1] == 1 && ms[instanceIndex].x[@G_1] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_2] == 1 && ms[instanceIndex].x[@G_1] == 1 && ms[instanceIndex].x[@G_2] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_3] == 1 && ms[instanceIndex].x[@G_1] == 1 && ms[instanceIndex].x[@G_3] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_4] == 1 && ms[instanceIndex].x[@G_1] == 1 && ms[instanceIndex].x[@G_4] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_2_1] == 1 && ms[instanceIndex].x[@G_2] == 1 && ms[instanceIndex].x[@G_1] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_2] == 1 && ms[instanceIndex].x[@G_2] == 1 && ms[instanceIndex].x[@G_2] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_3] == 1 && ms[instanceIndex].x[@G_2] == 1 && ms[instanceIndex].x[@G_3] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_4] == 1 && ms[instanceIndex].x[@G_2] == 1 && ms[instanceIndex].x[@G_4] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_3_1] == 1 && ms[instanceIndex].x[@G_3] == 1 && ms[instanceIndex].x[@G_1] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_2] == 1 && ms[instanceIndex].x[@G_3] == 1 && ms[instanceIndex].x[@G_2] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_3] == 1 && ms[instanceIndex].x[@G_3] == 1 && ms[instanceIndex].x[@G_3] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_4] == 1 && ms[instanceIndex].x[@G_3] == 1 && ms[instanceIndex].x[@G_4] == 1 && ms[instanceIndex].x[@A_3_3] != 1 || ms[instanceIndex].x[@A_1_1] == 1 && ms[instanceIndex].x[@R_1] == 1 && ms[instanceIndex].x[@R_1] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_2] == 1 && ms[instanceIndex].x[@R_1] == 1 && ms[instanceIndex].x[@R_2] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_3] == 1 && ms[instanceIndex].x[@R_1] == 1 && ms[instanceIndex].x[@R_3] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_1_4] == 1 && ms[instanceIndex].x[@R_1] == 1 && ms[instanceIndex].x[@R_4] == 1 && ms[instanceIndex].x[@A_1_1] != 1 && ms[instanceIndex].x[@A_2_1] == 1 && ms[instanceIndex].x[@R_2] == 1 && ms[instanceIndex].x[@R_1] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_2] == 1 && ms[instanceIndex].x[@R_2] == 1 && ms[instanceIndex].x[@R_2] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_3] == 1 && ms[instanceIndex].x[@R_2] == 1 && ms[instanceIndex].x[@R_3] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_2_4] == 1 && ms[instanceIndex].x[@R_2] == 1 && ms[instanceIndex].x[@R_4] == 1 && ms[instanceIndex].x[@A_2_2] != 1 && ms[instanceIndex].x[@A_3_1] == 1 && ms[instanceIndex].x[@R_3] == 1 && ms[instanceIndex].x[@R_1] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_2] == 1 && ms[instanceIndex].x[@R_3] == 1 && ms[instanceIndex].x[@R_2] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_3] == 1 && ms[instanceIndex].x[@R_3] == 1 && ms[instanceIndex].x[@R_3] == 1 && ms[instanceIndex].x[@A_3_3] != 1 && ms[instanceIndex].x[@A_3_4] == 1 && ms[instanceIndex].x[@R_3] == 1 && ms[instanceIndex].x[@R_4] == 1 && ms[instanceIndex].x[@A_3_3] != 1) -> r9 = true;
	::	else -> skip;
	fi;


	/* Rewriting and Communication Rules */
	do
	:: (r9 && ms[instanceIndex].x[@s] >= 1) ->
			d_step {
				doLhs(instanceIndex, @s, 1);
			}
	:: (r10 && ms[instanceIndex].x[@X] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X, 1);
				doRhs(instanceIndex, @Y, 1);
			}
	:: (r11 && ms[instanceIndex].x[@Y] >= 1 && ms[instanceIndex].x[@s] >= 1) ->
			d_step {
				doLhs(instanceIndex, @Y, 1);
				doLhs(instanceIndex, @s, 1);
				doReplicate(2, @T, 1);
			}
	:: else -> break;
	od;

	/* Division Rules */
	if
	:: (r1 && ms[instanceIndex].x[@A_1] >= 1) ->
			d_step {
				doLhs(instanceIndex, @A_1, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @R_1, 1);
				doRhs(instanceIndex, @A_2, 1);
				doRhs(instanceCount - 1, @T_1, 1);
			}
	:: (r2 && ms[instanceIndex].x[@A_2] >= 1) ->
			d_step {
				doLhs(instanceIndex, @A_2, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @R_2, 1);
				doRhs(instanceIndex, @A_3, 1);
				doRhs(instanceCount - 1, @T_2, 1);
			}
	:: (r3 && ms[instanceIndex].x[@A_3] >= 1) ->
			d_step {
				doLhs(instanceIndex, @A_3, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @R_3, 1);
				doRhs(instanceIndex, @A_4, 1);
				doRhs(instanceCount - 1, @T_3, 1);
			}
	:: (r4 && ms[instanceIndex].x[@T_1] >= 1) ->
			d_step {
				doLhs(instanceIndex, @T_1, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @B_1, 1);
				doRhs(instanceIndex, @A_2, 1);
				doRhs(instanceCount - 1, @G_1, 1);
				doRhs(instanceCount - 1, @A_2, 1);
			}
	:: (r5 && ms[instanceIndex].x[@T_2] >= 1) ->
			d_step {
				doLhs(instanceIndex, @T_2, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @B_2, 1);
				doRhs(instanceIndex, @A_3, 1);
				doRhs(instanceCount - 1, @G_2, 1);
				doRhs(instanceCount - 1, @A_3, 1);
			}
	:: (r6 && ms[instanceIndex].x[@T_3] >= 1) ->
			d_step {
				doLhs(instanceIndex, @T_3, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @B_3, 1);
				doRhs(instanceIndex, @A_4, 1);
				doRhs(instanceCount - 1, @G_3, 1);
				doRhs(instanceCount - 1, @A_4, 1);
			}
	:: (r7 && ms[instanceIndex].x[@A_4] >= 1) ->
			d_step {
				doLhs(instanceIndex, @A_4, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @R_4, 1);
				doRhs(instanceIndex, @X, 1);
				doRhs(instanceCount - 1, @T_4, 1);
			}
	:: (r8 && ms[instanceIndex].x[@T_4] >= 1) ->
			d_step {
				doLhs(instanceIndex, @T_4, 1);
				divide(instanceIndex, 2);
				doRhs(instanceIndex, @B_4, 1);
				doRhs(instanceIndex, @X, 1);
				doRhs(instanceCount - 1, @G_4, 1);
				doRhs(instanceCount - 1, @X, 1);
			}
	:: else -> skip;
	fi;

	ms[instanceIndex].isComputing = false;
}

proctype M1(int instanceIndex) {

	ms[instanceIndex].isComputing = true;

	/* Guard Evaluations */
	byte r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11, r12;
	r1 = true; r2 = true; r3 = true; r4 = true; r5 = true; r6 = true; r7 = true; r8 = true; r9 = true; r10 = true; r11 = true; r12 = false;
	if
	::	(ms[instanceIndex].x[@T] < 1) -> r12 = true;
	::	else -> skip;
	fi;


	/* Rewriting and Communication Rules */
	do
	:: (r1 && ms[instanceIndex].x[@X_1] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_1, 1);
				doRhs(instanceIndex, @X_2, 1);
			}
	:: (r2 && ms[instanceIndex].x[@X_2] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_2, 1);
				doRhs(instanceIndex, @X_3, 1);
			}
	:: (r3 && ms[instanceIndex].x[@X_3] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_3, 1);
				doRhs(instanceIndex, @X_4, 1);
			}
	:: (r4 && ms[instanceIndex].x[@X_4] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_4, 1);
				doRhs(instanceIndex, @X_5, 1);
			}
	:: (r5 && ms[instanceIndex].x[@X_5] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_5, 1);
				doRhs(instanceIndex, @X_6, 1);
			}
	:: (r6 && ms[instanceIndex].x[@X_6] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_6, 1);
				doRhs(instanceIndex, @X_7, 1);
			}
	:: (r7 && ms[instanceIndex].x[@X_7] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_7, 1);
				doRhs(instanceIndex, @X_8, 1);
			}
	:: (r8 && ms[instanceIndex].x[@X_8] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_8, 1);
				doRhs(instanceIndex, @X_9, 1);
			}
	:: (r9 && ms[instanceIndex].x[@X_9] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_9, 1);
				doRhs(instanceIndex, @X_10, 1);
			}
	:: (r10 && ms[instanceIndex].x[@X_10] >= 1) ->
			d_step {
				doLhs(instanceIndex, @X_10, 1);
				doRhs(instanceIndex, @X_11, 1);
			}
	:: (r11 && ms[instanceIndex].x[@a] >= 1 && ms[instanceIndex].x[@T] >= 1) ->
			d_step {
				doLhs(instanceIndex, @a, 1);
				doLhs(instanceIndex, @T, 1);
				doReplicate(3, @yes, 1);
			}
	:: (r12 && ms[instanceIndex].x[@a] >= 1 && ms[instanceIndex].x[@X_11] >= 1) ->
			d_step {
				doLhs(instanceIndex, @a, 1);
				doLhs(instanceIndex, @X_11, 1);
				doReplicate(3, @no, 1);
			}
	:: else -> break;
	od;


	ms[instanceIndex].isComputing = false;
}

init {
	/* Instance 0 */
	ms[0].type = 3;


	/* Instance 1 */
	ms[1].type = 2;
	ms[1].x[@a] = 1;
	ms[1].x[@X_1] = 1;

	/* Instance 2 */
	ms[2].type = 1;
	ms[2].x[@A_1] = 1;
	ms[2].x[@s] = 1;
	ms[2].x[@A_1_2] = 1;
	ms[2].x[@A_1_3] = 1;
	ms[2].x[@A_2_3] = 1;
	ms[2].x[@A_2_4] = 1;
	ms[2].x[@A_3_4] = 1;

	instanceCount = 3;

	//run Log(-1);

	run Scheduler();
}